                              MEMBER

  INCLUDE('UltimateVLB.inc'),ONCE
  INCLUDE('Equates.clw'),ONCE
  INCLUDE('Errors.clw'),ONCE
  INCLUDE('Keycodes.clw'),ONCE

                              ITEMIZE
ELEMENT:DisplayValue            EQUATE(1)
ELEMENT:NormalFG                EQUATE
ELEMENT:NormalBG                EQUATE
ELEMENT:SelectedFG              EQUATE
ELEMENT:SelectedBG              EQUATE
ELEMENT:Icon                    EQUATE
ELEMENT:Level                   EQUATE
ELEMENT:Style                   EQUATE
                              END

                              MAP
                                MODULE('Windows API')
WinAPI:GetSysColor                PROCEDURE(SIGNED nIndex),LONG,PASCAL,NAME('GetSysColor')
                                END
                                INCLUDE('CWUtil.inc')
                                INCLUDE('STDebug.inc')
                              END

LONG_NoIcon                   LONG(0)
LONG_COLOR:NONE               LONG(COLOR:NONE)

!==============================================================================
!==============================================================================
UltVLB:ColumnClass.Construct  PROCEDURE
  CODE
  SELF.Width          = UltVLB:Width:String
  SELF.Justification  = UltVLB:Justify:Left;  SELF.Offset  = UltVLB:Offset:Data
  SELF.HJustification = UltVLB:Justify:Left;  SELF.HOffset = UltVLB:Offset:Header
  SELF.IsResizable    = TRUE
  SELF.HasRightBorder = TRUE
  
!==============================================================================
UltVLB:ColumnClass.Destruct   PROCEDURE
  CODE
  !Empty virtual

!==============================================================================
UltVLB:ColumnClass.FormatColumn   PROCEDURE(SIGNED ListFEQ,SHORT ColumnNo)
  CODE
  ListFEQ{PROPLIST:Width    , ColumnNo} = SELF.Width
  ListFEQ{PROPLIST:Header   , ColumnNo} = SELF.Header
  ListFEQ{PROPLIST:Picture  , ColumnNo} = SELF.Picture
  CASE SELF.Justification
    ;OF UltVLB:Justify:Default ;  !No-op
    ;OF UltVLB:Justify:Left    ;  ListFEQ{PROPLIST:Left        , ColumnNo} = TRUE;  ListFEQ{PROPLIST:LeftOffset  , ColumnNo} = SELF.Offset
    ;OF UltVLB:Justify:Right   ;  ListFEQ{PROPLIST:Right       , ColumnNo} = TRUE;  ListFEQ{PROPLIST:RightOffset , ColumnNo} = SELF.Offset
    ;OF UltVLB:Justify:Center  ;  ListFEQ{PROPLIST:Center      , ColumnNo} = TRUE;  ListFEQ{PROPLIST:CenterOffset, ColumnNo} = SELF.Offset
  END
  CASE SELF.HJustification
    ;OF UltVLB:Justify:Default ;  !No-op
    ;OF UltVLB:Justify:Left    ;  ListFEQ{PROPLIST:HeaderLeft  , ColumnNo} = TRUE;  ListFEQ{PROPLIST:HeaderLeftOffset  , ColumnNo} = SELF.HOffset
    ;OF UltVLB:Justify:Right   ;  ListFEQ{PROPLIST:HeaderRight , ColumnNo} = TRUE;  ListFEQ{PROPLIST:HeaderRightOffset , ColumnNo} = SELF.HOffset
    ;OF UltVLB:Justify:Center  ;  ListFEQ{PROPLIST:HeaderCenter, ColumnNo} = TRUE;  ListFEQ{PROPLIST:HeaderCenterOffset, ColumnNo} = SELF.HOffset
  END
  CASE SELF.Icon
    ;OF UltVLB:Icon:Regular    ;  ListFEQ{PROPLIST:Icon        , ColumnNo} = TRUE
    ;OF UltVLB:Icon:Transparent;  ListFEQ{PROPLIST:IconTrn     , ColumnNo} = TRUE
  END
  ListFEQ{PROPLIST:Color      , ColumnNo} = CHOOSE(SELF.Color <> UltVLB:Color:None)
  ListFEQ{PROPLIST:RightBorder, ColumnNo} = SELF.HasRightBorder
  ListFEQ{PROPLIST:Resize     , ColumnNo} = SELF.IsResizable

!==============================================================================
UltVLB:ColumnClass.GetElementCount       PROCEDURE!,SHORT
Elements                        SHORT(0)
  CODE
  ;                                       Elements += 1
  IF SELF.Color <> UltVLB:Color:None THEN Elements += 4.
  IF SELF.Icon  <> UltVLB:Icon:None  THEN Elements += 1.
  IF SELF.HasStyle                   THEN Elements += 1.
  IF SELF.HasTree                    THEN Elements += 1.
  RETURN Elements

!==============================================================================
UltVLB:ColumnClass.GetElementLONG PROCEDURE(SHORT Elem)!,LONG
  CODE
  ST::Debug('GetElementLONG/'& Elem)
  EXECUTE Elem - 1
    RETURN COLOR:NONE;  !NormalFG
    RETURN COLOR:NONE;  !NormalBG  
    RETURN COLOR:NONE;  !SelectedFG
    RETURN COLOR:NONE;  !SelectedBG
    RETURN SELF.IconRef
    RETURN COLOR:NONE;  !Level     
    RETURN COLOR:NONE;  !Style     
  END
  RETURN COLOR:NONE  !TODO
  
!==============================================================================
UltVLB:ColumnClass.GetElementSTRING   PROCEDURE(SHORT Elem)!,STRING
  CODE
  IF Elem = ELEMENT:DisplayValue
    RETURN SELF.GetValue()
  ELSE
    RETURN SELF.GetElementLONG(Elem)
  END
  
!==============================================================================
UltVLB:ColumnClass.GetValue   PROCEDURE!,STRING
  CODE
  IF NOT SELF.FieldRef &= NULL
    RETURN SELF.FieldRef
  ELSE
    RETURN ''
  END

!==============================================================================
UltVLB:ColumnClass.ScrapeProperties   PROCEDURE(SIGNED ListFeq,QUEUE Q,LONG ColNo)
                              MAP
ScrapeJustification             PROCEDURE
ScrapeHeaderJustification       PROCEDURE
AssignFieldRefs                 PROCEDURE
ScrapeColor                     PROCEDURE
ScrapeIcon                      PROCEDURE
                              END
AttributeFieldOffset                    BYTE(0)
  CODE
  SELF.Header  = ListFeq{PROPLIST:Header, ColNo}
  SELF.Picture = ListFeq{PROPLIST:Picture, ColNo}
  SELF.Width   = ListFeq{PROPLIST:Width, ColNo}
  ScrapeJustification
  ScrapeHeaderJustification
  AssignFieldRefs
  ScrapeColor
  ScrapeIcon

ScrapeJustification           PROCEDURE
  CODE
  IF ListFeq{PROPLIST:Left, ColNo}
    SELF.Justification = UltVLB:Justify:Left
    SELF.Offset        = ListFeq{PROPLIST:LeftOffset, ColNo}
  ELSIF ListFeq{PROPLIST:Right, ColNo}
    SELF.Justification = UltVLB:Justify:Right
    SELF.Offset        = ListFeq{PROPLIST:RightOffset, ColNo}
  ELSIF ListFeq{PROPLIST:Center, ColNo}
    SELF.Justification = UltVLB:Justify:Center
    SELF.Offset        = ListFeq{PROPLIST:CenterOffset, ColNo}
  ELSE
    SELF.Justification = UltVLB:Justify:Default
    SELF.Offset        = 0
  END

ScrapeHeaderJustification     PROCEDURE
  CODE
  IF ListFeq{PROPLIST:HeaderLeft, ColNo}
    SELF.HJustification = UltVLB:Justify:Left
    SELF.HOffset        = ListFeq{PROPLIST:HeaderLeftOffset, ColNo}
  ELSIF ListFeq{PROPLIST:HeaderRight, ColNo}
    SELF.HJustification = UltVLB:Justify:Right
    SELF.HOffset        = ListFeq{PROPLIST:HeaderRightOffset, ColNo}
  ELSIF ListFeq{PROPLIST:HeaderCenter, ColNo}
    SELF.HJustification = UltVLB:Justify:Center
    SELF.HOffset        = ListFeq{PROPLIST:HeaderCenterOffset, ColNo}
  ELSE
    SELF.HJustification = UltVLB:Justify:Default
    SELF.HOffset        = 0
  END

AssignFieldRefs               PROCEDURE
  CODE
  SELF.FieldNo   = ListFeq{PROPLIST:FieldNo, ColNo}
  SELF.FieldRef &= WHAT(Q, SELF.FieldNo)

ScrapeColor                   PROCEDURE
  CODE
  IF ListFeq{PROPLIST:Color, ColNo}
    SELF.Color = UltVLB:Color:Regular
  ELSE
    SELF.Color = UltVLB:Color:Pretend
  END
  
ScrapeIcon                    PROCEDURE
  CODE
  IF ListFeq{PROPLIST:IconTrn, ColNo}
    SELF.Icon = UltVLB:Icon:Transparent
    DO AssignIconRef
  ELSIF ListFeq{PROPLIST:Icon, ColNo}
    SELF.Icon = UltVLB:Icon:Regular
    DO AssignIconRef
  ELSE
    SELF.Icon     = UltVLB:Icon:None
    SELF.IconRef &= LONG_NoIcon
  END
  
AssignIconRef                 ROUTINE
  AttributeFieldOffset += 1
  SELF.IconRef &= WHAT(Q, SELF.FieldNo + AttributeFieldOffset)

!==============================================================================
!==============================================================================
UltVLB:ColumnClassForNumber.Construct PROCEDURE
  CODE
  SELF.Width          = UltVLB:Width:Number
  SELF.Justification  = UltVLB:Justify:Right ;  SELF.Offset  = UltVLB:Offset:Data
  SELF.HJustification = UltVLB:Justify:Center;  SELF.HOffset = 0

!==============================================================================
!==============================================================================
UltimateVLB.Construct           PROCEDURE
  CODE
  SELF.ColumnQueue &= NEW UltVLB:ColumnQueue

!==============================================================================
UltimateVLB.Destruct            PROCEDURE
  CODE
  LOOP WHILE RECORDS(SELF.ColumnQueue)
    GET(SELF.ColumnQueue, 1)
    IF SELF.ColumnQueue.DisposeObject
      DISPOSE(SELF.ColumnQueue.Column)
    END
    DELETE(SELF.ColumnQueue)
  END
  DISPOSE(SELF.ColumnQueue)

!==============================================================================
UltimateVLB.Init              PROCEDURE(SIGNED FEQ,<QUEUE ListQueue>)
                              MAP
AssignVLB                       PROCEDURE
AssignListAttributes            PROCEDURE
DeriveStripeColorFromBarColor   PROCEDURE
FormatColumns                   PROCEDURE
                              END
  CODE
  SELF.FEQ                = FEQ
  SELF.ListQueue         &= ListQueue
  SELF.OriginalListHeight = FEQ{PROP:Height}
  SELF.MeasureList
  DeriveStripeColorFromBarColor
  AssignListAttributes
  SELF.GetElementCount()  !From Columns
  FormatColumns
  !MESSAGE(FEQ{PROP:Format})
  AssignVLB
  
!--------------------------------------
AssignVLB                     PROCEDURE
  CODE
  SELF.FEQ{PROP:VLBval } = ADDRESS(SELF)           !Must assign this first
  SELF.FEQ{PROP:VLBproc} = ADDRESS(SELF.VLBproc)    ! then this

!--------------------------------------
AssignListAttributes          PROCEDURE
  CODE
  SELF.FEQ{PROP:VScroll} = TRUE

!--------------------------------------
DeriveStripeColorFromBarColor PROCEDURE
H                               REAL
S                               REAL
L                               REAL
COLOR_HIGHLIGHT                 EQUATE(13)
  CODE
  SELF.StripeColor = feq{PROP:SelectedFillColor}
  IF SELF.StripeColor = COLOR:NONE
    SELF.StripeColor = WinAPI:GetSysColor(COLOR_HIGHLIGHT)
  END
  ColorToHSL(SELF.StripeColor, H, S, L)
  HSLToColor(H, S, (L+5)/6, SELF.StripeColor)

!--------------------------------------
FormatColumns                 PROCEDURE
                              MAP
CreateFormatStringToSignalNumberOfColumns   PROCEDURE
                              END
C                               BYTE,AUTO
  CODE
  CreateFormatStringToSignalNumberOfColumns
  LOOP C = 1 TO RECORDS(SELF.ColumnQueue)
    GET(SELF.ColumnQueue, C)
    SELF.ColumnQueue.Column.FormatColumn(SELF.FEQ, C)
  END
  
!..................
CreateFormatStringToSignalNumberOfColumns PROCEDURE
F                                           CSTRING(10000)
  CODE
  LOOP C = 1 TO RECORDS(SELF.ColumnQueue)
    F = F & '1L'
  END
  feq{PROP:Format} = F
  
!==============================================================================
UltimateVLB.AddColumn         PROCEDURE(UltVLB:ColumnClass C,<BOOL DisposeObject>)
  CODE
  CLEAR(SELF.ColumnQueue)
  SELF.ColumnQueue.Column       &= C
  SELF.ColumnQueue.DisposeObject = DisposeObject
  SELF.ColumnQueue.ElementCount  = C.GetElementCount()
  ADD(SELF.ColumnQueue)

!==============================================================================
UltimateVLB.GetColumnValue    PROCEDURE(LONG Row,SHORT Col)!,STRING
  CODE
  RETURN ''

!==============================================================================
UltimateVLB.FetchRow          PROCEDURE(LONG Row)!,BYTE
  CODE
  IF NOT SELF.ListQueue &= NULL
    GET(SELF.ListQueue, Row)
    RETURN CHOOSE(ERRORCODE()=NoError, Level:Benign, Level:Notify)
  ELSE
    RETURN Level:Notify
  END

!==============================================================================
UltimateVLB.GetElement        PROCEDURE(LONG Row,SHORT Elem)!,STRING
Column                          SHORT(0)
ElementValue                    LONG
ElemOffset                      BYTE
  CODE
  LOOP UNTIL Column = RECORDS(SELF.ColumnQueue)
    Column += 1
    GET(SELF.ColumnQueue, Column)
    IF Elem <= SELF.ColumnQueue.ElementCount
      IF SELF.FetchRow(Row) = Level:Benign
        IF Elem = ELEMENT:DisplayValue
          RETURN SELF.ColumnQueue.Column.GetValue()
        ELSE
          ElemOffset = 1
          IF SELF.ColumnQueue.Column.Color <> UltVLB:Color:None
            EXECUTE Elem - ElemOffset
              RETURN SELF.ColumnQueue.Column.GetElementLONG(ELEMENT:NormalFG)
              BEGIN
                ElementValue = SELF.ColumnQueue.Column.GetElementLONG(ELEMENT:NormalBG)
                IF ElementValue = COLOR:NONE
                  RETURN SELF.GetStripeColor(Row)
                ELSE
                  RETURN ElementValue
                END
              END
              RETURN SELF.ColumnQueue.Column.GetElementLONG(ELEMENT:SelectedFG)
              RETURN SELF.ColumnQueue.Column.GetElementLONG(ELEMENT:SelectedBG)
            END
            ElemOffset += 4
          END
          IF SELF.ColumnQueue.Column.Icon <> UltVLB:Icon:None
            IF Elem - ElemOffset = 1
              RETURN SELF.ColumnQueue.Column.GetElementLONG(ELEMENT:Icon)
            END
            ElemOffset += 1
          END
          RETURN 0  !TODO
        END
      ELSE
        BREAK
      END
    ELSE
      Elem -= SELF.ColumnQueue.ElementCount
    END
  END
  RETURN ''

!==============================================================================
UltimateVLB.GetElementCount   PROCEDURE!,SHORT
Col                             SHORT,AUTO
  CODE
  IF SELF.ElementCount = 0
    LOOP Col = 1 TO RECORDS(SELF.ColumnQueue)
      GET(SELF.ColumnQueue, Col)
      SELF.ElementCount += SELF.ColumnQueue.Column.GetElementCount()
    END
  END
  !ST::Debug('GetElementCount: '& SELF.ElementCount)
  RETURN SELF.ElementCount
  
!==============================================================================
UltimateVLB.GetStripeColor    PROCEDURE(LONG Row)!,LONG
  CODE
  RETURN CHOOSE(BAND(Row,1), COLOR:NONE, SELF.StripeColor)
  
!==============================================================================
UltimateVLB.HasDataChanged    PROCEDURE!,BOOL
NewCHANGES                      LONG
  CODE
  IF SELF.ListQueue &= NULL
    RETURN FALSE
  ELSE
    NewCHANGES = CHANGES(SELF.ListQueue)
    !ST::Debug('Old='& SELF.OldChanges &'; New='& NewCHANGES)
    IF NewCHANGES <> SELF.OldCHANGES
      SELF.OldCHANGES = NewCHANGES
      RETURN TRUE
    ELSE
      RETURN FALSE
    END
  END
  
!==============================================================================
UltimateVLB.MeasureList       PROCEDURE
  CODE
  SELF.ListItems       = SELF.FEQ{PROP:Items}
  SELF.FEQ{PROP:Items} = SELF.ListItems
  
!==============================================================================
UltimateVLB.Records           PROCEDURE(BYTE ReturnAtLeastOnePage=1)!,LONG
R                               LONG(0)
  CODE
  IF NOT SELF.ListQueue &= NULL
    R = RECORDS(SELF.ListQueue)
!    IF ReturnAtLeastOnePage AND R < SELF.ListItems
!      R = SELF.ListItems.
!    END
  END
  RETURN R
  
!==============================================================================
UltimateVLB.VLBproc           PROCEDURE(LONG Row, SHORT Elem)  !Required first parameter is implied
VLB:RowParm:RecordCount         EQUATE(-1)
VLB:RowParm:ElementCount        EQUATE(-2)
VLB:RowParm:HasChanges          EQUATE(-3)
Recs                            LONG,AUTO
ElementCount                    LONG,AUTO
HasDataChanged                  BOOL,AUTO
  CODE
  CASE Row
    ;OF VLB:RowParm:RecordCount ;  Recs = SELF.Records()
    ;                           ;  !ST::Debug('VLB:RecordCount='& Recs)
    ;                           ;  RETURN Recs
    ;OF VLB:RowParm:ElementCount;  ElementCount = SELF.GetElementCount()
    ;                           ;  !ST::Debug('VLB:GetElems='& ElementCount)
    ;                           ;  RETURN ElementCount
    ;OF VLB:RowParm:HasChanges  ;  HasDataChanged = SELF.HasDataChanged()
    ;                           ;  !ST::Debug('VLB:HasChanged='& HasDataChanged)
    ;                           ;  RETURN HasDataChanged
    ;ELSE                       ;  !ST::Debug('VLB:GetElem['& Row &':'& Elem &']='& SELF.GetElement(Row, Elem))
    ;                           ;  RETURN SELF.GetElement(Row, Elem)
  END

!==============================================================================
